$(document).ready(function(){

	var FREQ = 10000 ;
	var wiederholen = true;

	frequenz_zeigen();
	lauefer_db_abfragen();
	AJAX_aufrufe_starten();
	
	function frequenz_zeigen(){
		$("#freq").html( "Seite wird alle " + FREQ/1000 + " Sekunden aktualisiert.");
	}
	
	function AJAX_aufrufe_starten(){
	
		if(wiederholen){
			setTimeout( function() {
					lauefer_db_abfragen();
					AJAX_aufrufe_starten();
				}, 	
				FREQ
			);
		}
	}

	// Aktuelle Zeit abfragen und ausgeben
	
	function aktuelle_zeit_ajax(){
		// var time = "";
		$.ajax({
			url: "http://localhost/jqhf/zeit.php",
			cache: false,
			success: function(data){
				$('#letzte_aktualisierung').html(data);
			}
		});
	}

	// Automatische Aktualisierungen starten und anhalten

	$("#stop_button").click(function(){
		wiederholen = false;
		$("#freq").html( "Aktualisierungen angehalten." );
	});

	$("#start_button").click(function(){
		wiederholen = true;
		AJAX_aufrufe_starten();
		frequenz_zeigen();
	});	

	// Datenbankeinträge auslesen und anzeigen

	function lauefer_db_abfragen(){
		$.getJSON("service.php?action=laeufer_abfragen", function(json) {
			if (json.laeufer.length > 0) {
				$('#finisher_m').empty();
				$('#finisher_w').empty();
				$('#finisher_alle').empty();	
				
				// Schleife über die zurückgegebenen Läufer
				$.each(json.laeufer,function() {
					var info = '<li>Name: ' +  this['vorname'] + ' ' +  this['nachname'] + '. Zeit: ' +  this['zeit'] + '</li>';
					// Die Informationen zum Geschlecht sind in der Datenbank
					// auf englisch gespeichert: m = male (männlich), f = female (weiblich)
					// Sie werden von service.php einfach an unser Skript durchgereicht.
					if(this['geschlecht'] == 'm'){
						$('#finisher_m').append( info );
					}else if(this['geschlecht'] == 'f'){
						$('#finisher_w').append( info );
					}else{}
					$('#finisher_alle').append( info );
				});
			}
		});
		aktuelle_zeit_ajax();
	}
	
	// Neue Läufer hinzufügen
	
	// Abschicken des Formulars abfangen
	$("#neuer_laeufer").submit(function(){
		return false;
	});
	
	// Klick auf den Absenden-Button...
	$('#sichern_button').click(function() {

		// Eingegebene Daten serialisieren...
		var data = $("#neuer_laeufer :input").serializeArray();

		// ...und per JSON an service.php schicken
		$.post($("#neuer_laeufer").attr('action'), data, function(json){
			
			// Bei Bedarf Meldungen von service.php als JS-Dialog ausgeben
			if (json.status == "fehler") {
				alert(json.nachricht);
			}
			if (json.status == "erfolg") {
				alert(json.nachricht);
				formular_zuruecksetzen();
			}
		}, "json");

	});	

	function formular_zuruecksetzen(){
		$("#txt_vorname").val('');
		$("#txt_nachname").val('');
		$("#liste_geschlecht").val('');
		$("#txt_minuten").val('');
		$("#txt_sekunden").val('');
	}	
	
});
